Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCBNormalPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCBNormalPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCBNormalPolicy.cs	(revision 11732)
@@ -7,24 +7,20 @@
 
 namespace HeuristicLab.Algorithms.Bandits {
-  public class UCBNormalPolicy : BanditPolicy {
-    private readonly int[] tries;
-    private readonly double[] sumReward;
-    private readonly double[] sumSqrReward;
-    private int totalTries = 0;
-    public UCBNormalPolicy(int numActions)
-      : base(numActions) {
-      this.tries = new int[numActions];
-      this.sumReward = new double[numActions];
-      this.sumSqrReward = new double[numActions];
-    }
+  public class UCBNormalPolicy : IPolicy {
 
-    public override int SelectAction() {
-      Debug.Assert(Actions.Any());
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<MeanAndVariancePolicyActionInfo>().ToArray(); // TODO: performance
       int bestAction = -1;
       double bestQ = double.NegativeInfinity;
-      foreach (var a in Actions) {
-        if (totalTries <= 1 || tries[a] <= 1 || tries[a] <= Math.Ceiling(8 * Math.Log(totalTries))) return a;
-        var avgReward = sumReward[a] / tries[a];
-        var estVariance = 16 * ((sumSqrReward[a] - tries[a] * Math.Pow(avgReward, 2)) / (tries[a] - 1)) * (Math.Log(totalTries - 1) / tries[a]);
+      int totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
+
+      for (int a = 0; a < myActionInfos.Length; a++) {
+        if (myActionInfos[a].Disabled) continue;
+        if (totalTries <= 1 || myActionInfos[a].Tries <= 1 || myActionInfos[a].Tries <= Math.Ceiling(8 * Math.Log(totalTries))) return a;
+
+        var tries = myActionInfos[a].Tries;
+        var avgReward = myActionInfos[a].AvgReward;
+        var rewardVariance = myActionInfos[a].RewardVariance;
+        var estVariance = 16 * rewardVariance * (Math.Log(totalTries - 1) / tries);
         if (estVariance < 0) estVariance = 0; // numerical problems
         var q = avgReward
@@ -35,40 +31,12 @@
         }
       }
-      Debug.Assert(Actions.Contains(bestAction));
+      Debug.Assert(bestAction > -1);
       return bestAction;
     }
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
-      totalTries++;
-      tries[action]++;
-      sumReward[action] += reward;
-      sumSqrReward[action] += reward * reward;
+
+    public IPolicyActionInfo CreateActionInfo() {
+      return new MeanAndVariancePolicyActionInfo();
     }
 
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      totalTries -= tries[action];
-      tries[action] = -1;
-      sumReward[action] = 0;
-      sumSqrReward[action] = 0;
-    }
-
-    public override void Reset() {
-      base.Reset();
-      totalTries = 0;
-      Array.Clear(tries, 0, tries.Length);
-      Array.Clear(sumReward, 0, sumReward.Length);
-      Array.Clear(sumSqrReward, 0, sumSqrReward.Length);
-    }
-    public override void PrintStats() {
-      for (int i = 0; i < sumReward.Length; i++) {
-        if (tries[i] >= 0) {
-          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
-        } else {
-          Console.Write("{0,5}", "");
-        }
-      }
-      Console.WriteLine();
-    }
     public override string ToString() {
       return "UCBNormalPolicy";
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCTPolicy.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCTPolicy.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.Bandits/Policies/UCTPolicy.cs	(revision 11732)
@@ -8,23 +8,22 @@
 namespace HeuristicLab.Algorithms.Bandits {
   /* Kocsis et al. Bandit based Monte-Carlo Planning */
-  public class UCTPolicy : BanditPolicy {
-    private readonly int[] tries;
-    private readonly double[] sumReward;
-    private int totalTries = 0;
+  public class UCTPolicy : IPolicy {
     private readonly double c;
 
-    public UCTPolicy(int numActions, double c = 1.0)
-      : base(numActions) {
-      this.tries = new int[numActions];
-      this.sumReward = new double[numActions];
+    public UCTPolicy(double c = 1.0) {
       this.c = c;
     }
 
-    public override int SelectAction() {
+
+    public int SelectAction(Random random, IEnumerable<IPolicyActionInfo> actionInfos) {
+      var myActionInfos = actionInfos.OfType<DefaultPolicyActionInfo>().ToArray(); // TODO: performance
       int bestAction = -1;
       double bestQ = double.NegativeInfinity;
-      foreach (var a in Actions) {
-        if (tries[a] == 0) return a;
-        var q = sumReward[a] / tries[a] + 2 * c * Math.Sqrt(Math.Log(totalTries) / tries[a]);
+      int totalTries = myActionInfos.Where(a => !a.Disabled).Sum(a => a.Tries);
+
+      for (int a = 0; a < myActionInfos.Length; a++) {
+        if (myActionInfos[a].Disabled) continue;
+        if (myActionInfos[a].Tries == 0) return a;
+        var q = myActionInfos[a].SumReward / myActionInfos[a].Tries + 2 * c * Math.Sqrt(Math.Log(totalTries) / myActionInfos[a].Tries);
         if (q > bestQ) {
           bestQ = q;
@@ -32,36 +31,12 @@
         }
       }
+      Debug.Assert(bestAction > -1);
       return bestAction;
     }
-    public override void UpdateReward(int action, double reward) {
-      Debug.Assert(Actions.Contains(action));
-      totalTries++;
-      tries[action]++;
-      sumReward[action] += reward;
+
+    public IPolicyActionInfo CreateActionInfo() {
+      return new DefaultPolicyActionInfo();
     }
 
-    public override void DisableAction(int action) {
-      base.DisableAction(action);
-      totalTries -= tries[action];
-      tries[action] = -1;
-      sumReward[action] = 0;
-    }
-
-    public override void Reset() {
-      base.Reset();
-      totalTries = 0;
-      Array.Clear(tries, 0, tries.Length);
-      Array.Clear(sumReward, 0, sumReward.Length);
-    }
-    public override void PrintStats() {
-      for (int i = 0; i < sumReward.Length; i++) {
-        if (tries[i] >= 0) {
-          Console.Write("{0,5:F2}", sumReward[i] / tries[i]);
-        } else {
-          Console.Write("{0,5}", "");
-        }
-      }
-      Console.WriteLine();
-    }
     public override string ToString() {
       return string.Format("UCTPolicy({0:F2})", c);
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesContextSampler.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesContextSampler.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesContextSampler.cs	(revision 11732)
@@ -17,12 +17,12 @@
     private readonly Random random;
     private readonly int contextLen;
-    private readonly Func<Random, int, IPolicy> policyFactory;
+    private readonly IPolicy policy;
 
-    public AlternativesContextSampler(IProblem problem, Random random, int maxLen, int contextLen, Func<Random, int, IPolicy> policyFactory) {
+    public AlternativesContextSampler(IProblem problem, Random random, int maxLen, int contextLen, IPolicy policy) {
       this.maxLen = maxLen;
       this.problem = problem;
       this.random = random;
       this.contextLen = contextLen;
-      this.policyFactory = policyFactory;
+      this.policy = policy;
     }
 
@@ -32,5 +32,5 @@
       for (int i = 0; i < maxIterations; i++) {
         var sentence = SampleSentence(problem.Grammar).ToString();
-        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
+        var quality = problem.Evaluate(sentence) / problem.BestKnownQuality(maxLen);
         DistributeReward(quality);
 
@@ -45,9 +45,9 @@
 
 
-    private Dictionary<string, IPolicy> ntPolicy;
+    private Dictionary<string, IPolicyActionInfo[]> contextActionInfos;
     private List<Tuple<string, int>> updateChain;
 
     private void InitPolicies(IGrammar grammar) {
-      this.ntPolicy = new Dictionary<string, IPolicy>();
+      this.contextActionInfos = new Dictionary<string, IPolicyActionInfo[]>();
       this.updateChain = new List<Tuple<string, int>>();
     }
@@ -83,8 +83,8 @@
           var lft = phrase.Subsequence(startIdx, endIdx - startIdx + 1).ToString();
           lft = problem.Hash(lft);
-          if (!ntPolicy.ContainsKey(lft)) {
-            ntPolicy.Add(lft, policyFactory(random, g.GetAlternatives(nt).Count()));
+          if (!contextActionInfos.ContainsKey(lft)) {
+            contextActionInfos.Add(lft, g.GetAlternatives(nt).Select(_ => policy.CreateActionInfo()).ToArray());
           }
-          var selectedAltIdx = ntPolicy[lft].SelectAction();
+          var selectedAltIdx = policy.SelectAction(random, contextActionInfos[lft]);
           selectedAlt = alts.ElementAt(selectedAltIdx);
           updateChain.Add(Tuple.Create(lft, selectedAltIdx));
@@ -103,5 +103,5 @@
         var lft = e.Item1;
         var action = e.Item2;
-        ntPolicy[lft].UpdateReward(action, reward);
+        contextActionInfos[lft][action].UpdateReward(reward);
       }
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesSampler.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesSampler.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/AlternativesSampler.cs	(revision 11732)
@@ -16,9 +16,11 @@
     private readonly Random random;
     private readonly IProblem problem;
+    private readonly IPolicy policy;
 
-    public AlternativesSampler(IProblem problem, int maxLen) {
+    public AlternativesSampler(IProblem problem, IPolicy policy, int maxLen) {
       this.problem = problem;
       this.maxLen = maxLen;
-      this.random = new Random(31415);
+      this.random = new Random();
+      this.policy = policy;
     }
 
@@ -28,5 +30,5 @@
       for (int i = 0; i < maxIterations; i++) {
         var sentence = SampleSentence(problem.Grammar).ToString();
-        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
+        var quality = problem.Evaluate(sentence) / problem.BestKnownQuality(maxLen);
         DistributeReward(quality);
 
@@ -41,12 +43,12 @@
 
 
-    private Dictionary<char, IPolicy> ntPolicy;
+    private Dictionary<char, IPolicyActionInfo[]> ntActionInfos;
     private List<Tuple<char, int>> updateChain;
 
     private void InitPolicies(IGrammar grammar) {
-      this.ntPolicy = new Dictionary<char, IPolicy>();
+      this.ntActionInfos = new Dictionary<char, IPolicyActionInfo[]>();
       this.updateChain = new List<Tuple<char, int>>();
       foreach (var nt in grammar.NonTerminalSymbols) {
-        ntPolicy.Add(nt, new EpsGreedyPolicy(random, grammar.GetAlternatives(nt).Count(), 0.1));
+        ntActionInfos.Add(nt, grammar.GetAlternatives(nt).Select(_ => policy.CreateActionInfo()).ToArray());
       }
     }
@@ -77,5 +79,5 @@
         } else {
           // all alts are allowed => select using bandit policy
-          var selectedAltIdx = ntPolicy[nt].SelectAction();
+          var selectedAltIdx = policy.SelectAction(random, ntActionInfos[nt]);
           selectedAlt = alts.ElementAt(selectedAltIdx);
           updateChain.Add(Tuple.Create(nt, selectedAltIdx));
@@ -95,5 +97,5 @@
         var nt = e.Item1;
         var action = e.Item2;
-        ntPolicy[nt].UpdateReward(action, reward);
+        ntActionInfos[nt][action].UpdateReward(reward);
       }
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveBreadthFirstSearch.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveBreadthFirstSearch.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveBreadthFirstSearch.cs	(revision 11732)
@@ -26,5 +26,5 @@
       for (int i = 0; sentenceEnumerator.MoveNext() && i < maxIterations; i++) {
         var sentence = sentenceEnumerator.Current.ToString();
-        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
+        var quality = problem.Evaluate(sentence) / problem.BestKnownQuality(maxLen);
         RaiseSolutionEvaluated(sentence, quality);
 
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveDepthFirstSearch.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveDepthFirstSearch.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveDepthFirstSearch.cs	(revision 11732)
@@ -26,5 +26,5 @@
       for (int i = 0; sentenceEnumerator.MoveNext() && i < maxIterations; i++) {
         var sentence = sentenceEnumerator.Current.ToString();
-        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
+        var quality = problem.Evaluate(sentence) / problem.BestKnownQuality(maxLen);
         RaiseSolutionEvaluated(sentence, quality);
 
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveRandomFirstSearch.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveRandomFirstSearch.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/ExhaustiveRandomFirstSearch.cs	(revision 11732)
@@ -0,0 +1,74 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.GrammaticalOptimization;
+
+namespace HeuristicLab.Algorithms.GrammaticalOptimization {
+  public class ExhaustiveRandomFirstSearch {
+    public event Action<string, double> FoundNewBestSolution;
+    public event Action<string, double> SolutionEvaluated;
+
+    private readonly int maxLen;
+    private readonly System.Collections.Generic.SortedList<double, Sequence> sortedList = new SortedList<double, Sequence>();
+    private readonly IProblem problem;
+    private readonly Random random;
+
+    public ExhaustiveRandomFirstSearch(IProblem problem, Random random, int maxLen) {
+      this.maxLen = maxLen;
+      this.problem = problem;
+      this.random = new Random();
+    }
+
+    public void Run(int maxIterations) {
+      double bestQuality = double.MinValue;
+      sortedList.Add(0, new Sequence(problem.Grammar.SentenceSymbol));
+      var sentences = GenerateLanguage(problem.Grammar);
+      var sentenceEnumerator = sentences.GetEnumerator();
+      for (int i = 0; sentenceEnumerator.MoveNext() && i < maxIterations; i++) {
+        var sentence = sentenceEnumerator.Current.ToString();
+        var quality = problem.Evaluate(sentence) / problem.BestKnownQuality(maxLen);
+        RaiseSolutionEvaluated(sentence, quality);
+
+        if (quality > bestQuality) {
+          bestQuality = quality;
+          RaiseFoundNewBestSolution(sentence, quality);
+        }
+      }
+    }
+
+    // create sentences lazily
+    private IEnumerable<Sequence> GenerateLanguage(IGrammar grammar) {
+      while (sortedList.Any()) {
+        var phrase = sortedList.First().Value;
+        sortedList.RemoveAt(0);
+
+        char nt = phrase.FirstNonTerminal;
+        var alts = grammar.GetAlternatives(nt);
+        foreach (var alt in alts) {
+          var newPhrase = new Sequence(phrase);
+          newPhrase.ReplaceAt(newPhrase.FirstNonTerminalIndex, 1, alt);
+
+          if (newPhrase.IsTerminal && newPhrase.Length <= maxLen) {
+            yield return newPhrase;
+          } else if (grammar.MinPhraseLength(newPhrase) <= maxLen) {
+            var r = random.NextDouble();
+            Sequence t;
+            while (sortedList.TryGetValue(r, out t)) { r = random.NextDouble(); }
+            sortedList.Add(r, newPhrase);
+          }
+        }
+      }
+    }
+
+
+    private void RaiseSolutionEvaluated(string sentence, double quality) {
+      var handler = SolutionEvaluated;
+      if (handler != null) handler(sentence, quality);
+    }
+    private void RaiseFoundNewBestSolution(string sentence, double quality) {
+      var handler = FoundNewBestSolution;
+      if (handler != null) handler(sentence, quality);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization.csproj
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization.csproj	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization.csproj	(revision 11732)
@@ -45,4 +45,5 @@
     <Compile Include="AlternativesSampler.cs" />
     <Compile Include="AlternativesContextSampler.cs" />
+    <Compile Include="ExhaustiveRandomFirstSearch.cs" />
     <Compile Include="MctsSampler.cs" />
     <Compile Include="ExhaustiveDepthFirstSearch.cs" />
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/MctsSampler.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/MctsSampler.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/MctsSampler.cs	(revision 11732)
@@ -13,5 +13,5 @@
       public int randomTries;
       public int policyTries;
-      public IPolicy policy;
+      public IPolicyActionInfo actionInfo;
       public TreeNode[] children;
       public bool done = false;
@@ -22,5 +22,5 @@
 
       public override string ToString() {
-        return string.Format("Node({0} tries: {1}, done: {2}, policy: {3})", ident, randomTries + policyTries, done, policy);
+        return string.Format("Node({0} tries: {1}, done: {2}, policy: {3})", ident, randomTries + policyTries, done, actionInfo);
       }
     }
@@ -34,7 +34,7 @@
     private readonly Random random;
     private readonly int randomTries;
-    private readonly Func<Random, int, IPolicy> policyFactory;
+    private readonly IPolicy policy;
 
-    private List<Tuple<TreeNode, int>> updateChain;
+    private List<TreeNode> updateChain;
     private TreeNode rootNode;
 
@@ -42,15 +42,15 @@
     public int treeSize;
 
-    public MctsSampler(IProblem problem, int maxLen, Random random) :
-      this(problem, maxLen, random, 10, (rand, numActions) => new EpsGreedyPolicy(rand, numActions, 0.1)) {
+    // public MctsSampler(IProblem problem, int maxLen, Random random) :
+    //   this(problem, maxLen, random, 10, (rand, numActions) => new EpsGreedyPolicy(rand, numActions, 0.1)) {
+    // 
+    // }
 
-    }
-
-    public MctsSampler(IProblem problem, int maxLen, Random random, int randomTries, Func<Random, int, IPolicy> policyFactory) {
+    public MctsSampler(IProblem problem, int maxLen, Random random, int randomTries, IPolicy policy) {
       this.maxLen = maxLen;
       this.problem = problem;
       this.random = random;
       this.randomTries = randomTries;
-      this.policyFactory = policyFactory;
+      this.policy = policy;
     }
 
@@ -60,5 +60,5 @@
       for (int i = 0; !rootNode.done && i < maxIterations; i++) {
         var sentence = SampleSentence(problem.Grammar).ToString();
-        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
+        var quality = problem.Evaluate(sentence) / problem.BestKnownQuality(maxLen);
         Debug.Assert(quality >= 0 && quality <= 1.0);
         DistributeReward(quality);
@@ -79,5 +79,5 @@
       var n = rootNode;
       Console.WriteLine("depth: {0,5} size: {1,10} root tries {2,10}", treeDepth, treeSize, rootNode.policyTries + rootNode.randomTries);
-      while (n.policy != null) {
+      while (n.children != null) {
         Console.WriteLine();
         Console.WriteLine("{0,5}->{1,-50}", n.ident, string.Join(" ", n.children.Select(ch => string.Format("{0,4}", ch.ident))));
@@ -90,7 +90,8 @@
 
     private void InitPolicies(IGrammar grammar) {
-      this.updateChain = new List<Tuple<TreeNode, int>>();
+      this.updateChain = new List<TreeNode>();
 
       rootNode = new TreeNode(grammar.SentenceSymbol.ToString());
+      rootNode.actionInfo = policy.CreateActionInfo();
       treeDepth = 0;
       treeSize = 0;
@@ -108,49 +109,49 @@
       TreeNode n = rootNode;
       bool done = phrase.IsTerminal;
-      int selectedAltIdx = -1;
       var curDepth = 0;
       while (!done) {
-        char nt = phrase.FirstNonTerminal;
-
-        int maxLenOfReplacement = maxLen - (phrase.Length - 1); // replacing aAb with maxLen 4 means we can only use alternatives with a minPhraseLen <= 2
-        Debug.Assert(maxLenOfReplacement > 0);
-
-        var alts = g.GetAlternatives(nt).Where(alt => g.MinPhraseLength(alt) <= maxLenOfReplacement);
+        updateChain.Add(n);
 
         if (n.randomTries < randomTries) {
           n.randomTries++;
+          treeDepth = Math.Max(treeDepth, curDepth);
+          return g.CompleteSentenceRandomly(random, phrase, maxLen);
+        } else {
+          char nt = phrase.FirstNonTerminal;
 
-          treeDepth = Math.Max(treeDepth, curDepth);
+          int maxLenOfReplacement = maxLen - (phrase.Length - 1); // replacing aAb with maxLen 4 means we can only use alternatives with a minPhraseLen <= 2
+          Debug.Assert(maxLenOfReplacement > 0);
 
-          return g.CompleteSentenceRandomly(random, phrase, maxLen);
-        } else if (n.randomTries == randomTries && n.policy == null) {
-          n.policy = policyFactory(random, alts.Count());
-          //n.children = alts.Select(alt => new TreeNode(alt.ToString())).ToArray(); // create a new node for each alternative
-          n.children = alts.Select(alt => new TreeNode(string.Empty)).ToArray(); // create a new node for each alternative
+          var alts = g.GetAlternatives(nt).Where(alt => g.MinPhraseLength(alt) <= maxLenOfReplacement);
 
-          treeSize += n.children.Length;
-        }
-        n.policyTries++;
-        // => select using bandit policy
-        selectedAltIdx = n.policy.SelectAction();
-        Sequence selectedAlt = alts.ElementAt(selectedAltIdx);
+          if (n.randomTries == randomTries && n.children == null) {
+            n.children = alts.Select(alt => new TreeNode(alt.ToString())).ToArray(); // create a new node for each alternative
+            //n.children = alts.Select(alt => new TreeNode(string.Empty)).ToArray(); // create a new node for each alternative
+            foreach (var ch in n.children) ch.actionInfo = policy.CreateActionInfo();
+            treeSize += n.children.Length;
+          }
+          n.policyTries++;
+          // => select using bandit policy
+          int selectedAltIdx = policy.SelectAction(random, n.children.Select(c => c.actionInfo));
+          Sequence selectedAlt = alts.ElementAt(selectedAltIdx);
 
-        // replace nt with alt
-        phrase.ReplaceAt(phrase.FirstNonTerminalIndex, 1, selectedAlt);
+          // replace nt with alt
+          phrase.ReplaceAt(phrase.FirstNonTerminalIndex, 1, selectedAlt);
 
-        updateChain.Add(Tuple.Create(n, selectedAltIdx));
+          curDepth++;
 
-        curDepth++;
+          done = phrase.IsTerminal;
 
-        done = phrase.IsTerminal;
-        if (!done) {
           // prepare for next iteration
           n = n.children[selectedAltIdx];
-          Debug.Assert(!n.done);
         }
       } // while
 
+      updateChain.Add(n);
+
+
       // the last node is a leaf node (sentence is done), so we never need to visit this node again
-      n.children[selectedAltIdx].done = true;
+      n.done = true;
+      n.actionInfo.Disable();
 
       treeDepth = Math.Max(treeDepth, curDepth);
@@ -163,12 +164,13 @@
 
       foreach (var e in updateChain) {
-        var node = e.Item1;
-        var policy = node.policy;
-        var action = e.Item2;
-        //policy.UpdateReward(action, reward / updateChain.Count);
-        policy.UpdateReward(action, reward);
-
-        if (node.children[action].done) node.policy.DisableAction(action);
-        if (node.children.All(c => c.done)) node.done = true;
+        var node = e;
+        if (node.children != null && node.children.All(c => c.done)) {
+          node.done = true;
+          node.actionInfo.Disable();
+        }
+        if (!node.done) {
+          node.actionInfo.UpdateReward(reward);
+          //policy.UpdateReward(action, reward / updateChain.Count);
+        }
       }
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/RandomSearch.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/RandomSearch.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/RandomSearch.cs	(revision 11732)
@@ -25,5 +25,5 @@
       for (int i = 0; i < maxIterations; i++) {
         var sentence = CreateSentence(problem.Grammar).ToString();
-        var quality = problem.Evaluate(sentence) / problem.GetBestKnownQuality(maxLen);
+        var quality = problem.Evaluate(sentence) / problem.BestKnownQuality(maxLen);
         RaiseSolutionEvaluated(sentence, quality);
 
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Common/Extensions.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Common/Extensions.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Common/Extensions.cs	(revision 11732)
@@ -29,4 +29,25 @@
       }
     }
+
+    public static double RSq(IEnumerable<double> xs, IEnumerable<double> ys) {
+      // two pass implementation, but we don't care
+      var meanX = xs.Average();
+      var meanY = ys.Average();
+
+      var s = 0.0;
+      var ssX = 0.0;
+      var ssY = 0.0;
+      foreach (var p in xs.Zip(ys, (x, y) => new { x, y })) {
+        s += (p.x - meanX) * (p.y - meanY);
+        ssX += Math.Pow(p.x - meanX, 2);
+        ssY += Math.Pow(p.y - meanY, 2);
+      }
+
+      if (s.IsAlmost(0)) return 0;
+      if (ssX.IsAlmost(0) || ssY.IsAlmost(0)) return 0;
+      return s * s / (ssX * ssY);
+    }
+
+
   }
 }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Common/Rand.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Common/Rand.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Common/Rand.cs	(revision 11732)
@@ -32,5 +32,5 @@
      * For Gamma(a,b), scale the result by b.
      */
-    private static double GammaRand(Random random, double a) {
+    public static double GammaRand(Random random, double a) {
       /* Algorithm:
        * G. Marsaglia and W.W. Tsang, A simple method for generating gamma
